#!/usr/bin/env python
from __future__ import generators
import findrox; findrox.version(1,9,12)
import rox
from rox import applet, g, InfoWin, tasks
#from rox.Menu import Menu, set_save_name
from rox.options import Option

import sys

from xml.dom import minidom
import xml.sax
import urllib

import gc
import os
import re

import time
import tool
import my_window	



from Options import *
from my_menu import *

global main
global updateset
global lastrefresh
global refreshset
global v # be verbose

#####################################################################################################
####### classes to store the news
#####################################################################################################
class message:
	def __init__(self, title, link, desc, time, fetchtime, count):
		self.title = title
		self.link  = link
		self.desc  = desc
		self.time  = time
		self.fetchtime = fetchtime
		self.count = count
	def _to_xml(self, parent):
		doc = parent.ownerDocument
		root = doc.createElement('item')
		parent.appendChild(root)
		node = doc.createElement('title')
		node.appendChild(doc.createTextNode(self.title))
		root.appendChild(node)
		node = doc.createElement('link')
		node.appendChild(doc.createTextNode(self.link))
		root.appendChild(node)
		node = doc.createElement('description')
		node.appendChild(doc.createTextNode(self.desc))
		root.appendChild(node)
		node = doc.createElement('time')
		node.appendChild(doc.createTextNode(str(self.time)))
		root.appendChild(node)
		node = doc.createElement('fetchtime')
		node.appendChild(doc.createTextNode(str(self.fetchtime)))
		root.appendChild(node)
		node = doc.createElement('count')
		node.appendChild(doc.createTextNode(str(self.count)))
		root.appendChild(node)
		return doc		

class feed:
	def __init__(self, title, active, ticker, icon, iconcache, \
			shownews, link, desc):
		self.title = title
		self.active = active
		self.ticker = ticker
		self.icon = icon
		self.iconcache = iconcache
		self.shownews = shownews
		self.link = link
		self.desc = desc
		self.msg = []
		self.valid = 1
		self.add_pos = 0
		self.cache_count = 0
	def _to_xml(self, parent):
		doc = parent.ownerDocument
		root = doc.createElement('feed')
		parent.appendChild(root)
		root_c = doc.createElement('channel')
		root.appendChild(root_c)
		node = doc.createElement('title')
		node.appendChild(doc.createTextNode(self.title))
		root_c.appendChild(node)
		node = doc.createElement('active')
		node.appendChild(doc.createTextNode(str(self.active)))
		root_c.appendChild(node)
		node = doc.createElement('ticker')
		node.appendChild(doc.createTextNode(self.ticker))
		root_c.appendChild(node)
		node = doc.createElement('icon')
		node.appendChild(doc.createTextNode(self.icon))
		root_c.appendChild(node)
		node = doc.createElement('iconcache')
		node.appendChild(doc.createTextNode(self.iconcache))
		root_c.appendChild(node)
		node = doc.createElement('shownews')
		node.appendChild(doc.createTextNode(str(self.shownews)))
		root_c.appendChild(node)
		node = doc.createElement('link')
		node.appendChild(doc.createTextNode(self.link))
		root_c.appendChild(node)
		node = doc.createElement('description')
		node.appendChild(doc.createTextNode(self.desc))
		root_c.appendChild(node)
		for i in self.msg:
			i._to_xml(root)
		return doc		
	def pop_cache(self):
		#lscht die Zahl der News, die ber die Cachezahl hinausgeht.
		while len(self.msg) > self.cache_count: self.msg.pop()
	def reinit(self):
		self.add_pos = 0
		self.cache_count = 0
	def cmp_msg(self, msg1, msg2):
		#print "c: " + msg1.title[:10] + " vs " + msg2.title[:10]
		if msg1.title <> msg2.title: return False	
		if msg1.link <> msg2.link: return False
		return True
	def add_msg(self,msg_new):
		self.cache_count += 1
		#print "try to add msg : " + msg_new.title[:10] + " at pos " + str(self.add_pos)
		for msg_old in self.msg:
			# prfe, ob message schon vorhanden
			if self.cmp_msg(msg_old, msg_new):
				return
		# hmm, sollte vielleicht prepend oder sowas sein ;)
		if msg_new.time <> 0:
			index = 0
			#suche die timeposition
			while index+1 < len(self.msg):
				index_time = self.msg[index].time
				if index_time == 0: index_time = self.msg[index].fetchtime
				if index_time < msg_new.time:
					self.msg.insert(index, msg_new)
					if index < self.add_pos: self.add_pos += 1
					return
				index += 1
			#nicht gefunden
			self.msg.append(msg_new)
		else:
			self.msg.insert(self.add_pos, msg_new)
			self.add_pos += 1
	
class show_list:
	def __init__(self):
		self.fd_count = 0
		self.msg_index = 0
		self.feed_jmp = 3 # init-wert
		self.error = ""
	def no_msg(self):
		self.error = "no messages"
		for fd in main.news.feeds:
			if fd.active == '1' and len(fd.msg) > 0 and \
				fd.shownews > 0:
				if news_age.int_value == 0: return False
				self.error = "only old messages"
				count = 1
				for i in fd.msg:
					if i.fetchtime + news_age.int_value*60 > time.time():
						return False
					count += 1
					if count > fd.shownews: break
		return True
	def next_msg(self):
		# sind news da oder ist lokaler Showcount berschritten?
		self.error = ""
		if self.feed_jmp == 1:
			self.msg_index = 0
			if self.fd_count + 1 < len(main.news.feeds):
				self.fd_count = self.fd_count + 1
			else:
				if self.no_msg(): return None
				self.fd_count = 0
		else:
			if self.feed_jmp <> 3: self.msg_index += 1
		self.feed_jmp = 0
		if self.akt_feed().active == '1' and \
			(self.akt_feed().shownews > self.msg_index) and \
			(len(self.akt_feed().msg) > self.msg_index):
				#if self.akt_msg().time <> 0: msg_time = self.akt_msg().time
				#else: msg_time = self.akt_msg().fetchtime
				msg_time = self.akt_msg().fetchtime
				if v:
					print "CompTime: "  + time.asctime(time.localtime(msg_time + news_age.int_value*60)) \
					 + " > " + time.asctime(time.localtime(time.time())) + " ?"
				if news_age.int_value == 0 or \
					msg_time + news_age.int_value*60 > time.time():
					return self.akt_msg()
		# check next feed
		self.feed_jmp = 1
		return self.next_msg()
	def akt_feed(self):
		return main.news.feeds[self.fd_count]
	def akt_msg(self):
		return self.akt_feed().msg[self.msg_index]
		
class news_:
	def __init__(self):
		self.feeds = []
		self.init = 0 # registriert, ob gecachte Daten gelesen werden
		tasks.Task(self.import_xml())
	def cmp_feed(self, fd1, fd2):
		if fd1.ticker <> fd2.ticker:
			#print "ungleich"
			return False
		if fd1.valid == 1:
			#print "valid"
			return False
		#print "gleich und nicht valid"
		fd1.valid = 1
		fd1.active = fd2.active
		fd1.icon = fd2.icon
		fd1.iconcache = fd2.iconcache
		fd1.shownews = fd2.shownews
		return True
	def stat(self):
		msg_count = 0
		allmsg_count = 0
		new_count = 0
		act_count = 0
		for fd in self.feeds:
			if fd.active == '1':
				act_count += 1
				msg_count += len(fd.msg)
				for msg in fd.msg:
					if msg.fetchtime + news_age.int_value*60 > time.time(): new_count += 1
			allmsg_count += len(fd.msg)
		stat =  "feeds: " + str(len(self.feeds)) + "[all]/" + str(act_count) + "[active] msg:" \
				+ str(allmsg_count) + "[all]/"+ str(msg_count) + "[active]/"+ str(new_count) + "[new]"
		return stat
	def export_xml(self):
		from xml.dom.minidom import Document
		doc = Document()
		root = doc.createElement('news')
		doc.appendChild(root)
		for i in self.feeds:
			i._to_xml(root)
		#print doc.toxml()
		if not xml_cache.value:
			return	# Saving is disabled
		file = open(xml_cache.value, 'w')
		doc.writexml(file)
		file.close()
	def import_xml(self):
		if v: print "import cached news ..."
		if not os.path.isfile(xml_cache.value): return
		if check_verbose.int_value: 
			main.box.label.update("import cached news ...")
			main.box.image.setStockConvert()
		if check_image.int_value:
			main.box.image.setStockConvert()
		yield None
		try:
			doc=minidom.parse(xml_cache.value)
		except xml.sax.SAXParseException:
			if v: print "parse error in cached news ..."
			if check_verbose.int_value: 
				main.box.label.update("parse error in cached news ...")
				main.box.image.get_from_file(fd.iconcache)
			if check_image.int_value:
				main.box.image.setStockCancel()
			yield tasks.TimeoutBlocker(2); return
		root = doc.documentElement
		assert root.localName == 'news'
		for o in root.childNodes:
			#self.wait = tasks.Blocker()
			#tasks.Task(self.read_xml(None, o))
			#yield self.wait
			self.read_xml(None, o)
		self.init = 1 # init done
		print "Cached news imported (" + self.stat() + ")"
	def read_xml(self, fd, xmldoc):
		def getdata(channel,name):
			c_name_s=channel.getElementsByTagName(name)
			c_name = ""
			if c_name_s:
				for t in c_name_s[0].childNodes:
					if t: c_name+=t.data
			return c_name
		channels=xmldoc.getElementsByTagName("channel")
		channel = channels[0]
		fd_title = getdata(channel, "title")
		ticker = getdata(channel, "ticker")
		link = getdata(channel, "link")
		desc = getdata(channel, "description")
		if self.init == 0:
			active = getdata(channel, "active")
			icon  = getdata(channel, "icon")
			iconcache = getdata(channel, "iconcache")
			shownews = getdata(channel, "shownews")
			fd = feed(fd_title, active, ticker, icon, iconcache,\
				shownews, link, desc)
			self.add_feed(fd)
		else:
			if fd_title <> "": fd.title = fd_title
			if link <> "": fd.link = link
			if desc <> "": fd.desc = desc
		#self.add_feed(fd)
		items=xmldoc.getElementsByTagName("item")
		#yield None
		fd.reinit()
		site_count = 0
		for i in items:
			if v: print "Checking " + fd_title + " (" + str(site_count) + ")"
			if check_verbose.int_value: 
				main.box.label.update("Checking " + fd_title \
							 + " (" + str(site_count) + ")");
			#yield None
			title = getdata(i, "title")
			# manchmal ist der Ticker nicht geupdated, dann bergehen
			if title == "": continue
			link = getdata(i, "link")
			desc = getdata(i, "description")
			if desc == "": desc="(keine weitere Info)"
			if self.init == 0:
				time_str = getdata(i, "time")
				if time_str == "": time_ = 0
				else: time_ = float(time_str)
				fetchtime_str = getdata(i, "fetchtime")
				if fetchtime_str == "":
					# should never happen
					fetchtime = 0
				else: fetchtime = float(fetchtime_str)
			else:
				time_str = getdata(i, "dc:date")
				if time_str == "": time_ = 0
				else: time_ = float(tool.conv_iso_time(time_str))
				fetchtime = time.time()
			count_str = getdata(i, "count")
			if count_str == "": count = 0
			else: count = int(count_str)
			tmp_msg = message(title, link, desc, time_, fetchtime, count)
			fd.add_msg(tmp_msg)
			#print str(fd_title) + " enthlt " + str(len(fd.msg)+1) + " Messages"
			site_count += 1
		fd.pop_cache()
		#self.wait.trigger()
	def add_feed(self,fd_new):
		#print len(self.feeds)
		for fd_indx in range(0, len(self.feeds)):
			# prfe, ob feed schon vorhanden
			if self.cmp_feed(self.feeds[fd_indx], fd_new):
				#print "schon da" 
				return fd_indx
		#print "anhngen" 
		self.feeds.append(fd_new)
		return len(self.feeds)-1
	def unvalid_all(self):
		for fd in self.feeds:
			fd.valid = 0
	def clean(self):
		i = 0
		while i+1 < len(self.feeds):
			if self.feeds[i].valid == 0:
				self.feeds.pop(i)
			else: i += 1

#####################################################################################################
####### functions to use for Window classes
#####################################################################################################

def quit(widget):
	#remove_icons()
	main.destroy()
	g.main_quit()

def callback_label(widget, event):
	global menu
	""" this function opens the browser with the third argument passed """
	if event.button == 1:
		tasks.Task(open_page())
        if event.button == 2:
		update_ticker()
	if event.button == 3:
		update_ticker()

def callback_image(widget, event):
	global menu
	""" this function opens the browser with the third argument passed """
	if event.button == 1:
		tasks.Task(open_page_feed())
        if event.button == 2:
		update_ticker()
	if event.button == 3:
		my_menu.open_menu(widget, event, main.position_menu)

def open_page():
	main.box.label.set_tip("opening page in browser")
	main.box.image.setStockConvert(); yield None
	os.spawnlp(os.P_NOWAIT,browser.value,browser.value,br_options.value,main.show_list.akt_msg().link) 

def open_page_feed():
	main.box.label.set_tip("opening page in browser")
	main.box.image.setStockConvert(); yield None
	os.spawnlp(os.P_NOWAIT,browser.value,browser.value,br_options.value,main.show_list.akt_feed().link) 

#####################################################################################################
####### functions to update or Refresh the ticker
#####################################################################################################

def update_ticker():
	global update_possible
	if update_possible == False:
		if v: print "update Ticker blocked"
		return False
	if v: print "update Ticker"
	global updatetimeout
	global updateset
       	g.timeout_remove(updatetimeout)
	updateset = False
	i = main.show_list.next_msg()
	if not(i):
		time_to_wait = int(refresh_time.int_value - (time.time() - lastrefresh)/60)
		if time_to_wait == 0:
			time_to_wait_s = str(int((refresh_time.int_value - (time.time() - lastrefresh)/60)*60)) + " seconds"
		else:
			time_to_wait_s = str(time_to_wait) + " minutes"
		main.box.label.update(main.show_list.error + ", waiting " + time_to_wait_s)
		main.box.label.tooltip.disable()
		main.box.image.setStockCancel()
       		main.box.image.tooltip.disable()
		updatetimeout = g.timeout_add(1000*update_time.int_value, update_ticker)
		updateset = True
		return True
	fd = main.news.feeds[main.show_list.fd_count]
	name = tool.unxml(i.title).encode("utf-8")
	main.box.label.update(name)
	main.box.image.get_from_file(fd.iconcache)
	
	addLabelTip(i)
	addImageTip(fd)
       	updatetimeout = g.timeout_add(1000*update_time.int_value, update_ticker)
	updateset = True
	return True

def addLabelTip(i):
	tooltip = ""
	if tt_l.int_value: 
		if tt_l_frame.int_value: tooltip += "---------------------------------------------\n"
		if tt_l_title.int_value: tooltip += tool.unxml(i.title).encode("utf-8") + "\n"
		if tt_l_frame.int_value: tooltip += "---------------------------------------------\n"
		tooltip += tool.unxml(i.desc).encode("utf-8") + "\n"
		if tt_l_frame.int_value: tooltip += "\n"
		if tt_l_link.int_value: tooltip += "Link   : " + tool.unxml(i.link).encode("utf-8") + "\n"
		if tt_l_ver.int_value:  tooltip += " *** " + Version + " *** "
		main.box.label.set_tip(tooltip)
	else:
		main.box.label.tooltip.disable()
	
def addImageTip(fd):
	tooltip = ""
	if tt_i.int_value: 
		if tt_i_frame.int_value: tooltip += "---------------------------------------------\n"
		if tt_i.int_value: tooltip += "Ticker : " + tool.unxml(fd.title).encode("utf-8") + "\n"
		if tt_i_frame.int_value: tooltip += "---------------------------------------------\n"
		if tt_i_desc.int_value: tool.unxml(fd.desc).encode("utf-8") + "\n"
		if tt_i_frame.int_value: tooltip += "\n"
		if tt_i_src.int_value: tooltip += "Src : " + tool.unxml(fd.ticker).encode("utf-8") + "\n"
		if tt_i_link.int_value: tooltip += "Link : " + tool.unxml(fd.link).encode("utf-8") + "\n"
		if tt_i_ver.int_value:  tooltip += " *** " + Version + " *** \n" + main.news.stat()
		main.box.image.set_tip(tooltip)
	else:
		main.box.image.tooltip.disable()
	

def start_refresh_ticker_task():
	tasks.Task(refresh_ticker())

def convert_sources(sources):
	doc = minidom.parseString(tool.unxml(sources.value))
	Index = 0
	main.news.unvalid_all()
	for value in doc.getElementsByTagName("source"):
		active = value.getElementsByTagName("active")[0].firstChild.data
		tick_elem = value.getElementsByTagName("ticker")[0].firstChild
		if tick_elem:
			ticker = tick_elem.data
			if ticker.find("://") == -1: ticker = "http://" + ticker
		else: ticker = ""
		icon_elem = value.getElementsByTagName("icon")[0].firstChild
		if icon_elem:
			icon = icon_elem.data
			if icon.find("://") == -1: icon = "http://" + icon
		else: 
			pos = ticker[8:].find("/")
			if pos <> -1: pos = pos + 8
			if pos <> -1: icon =  ticker[:pos] + "/favicon.ico"
			else:	icon =  ticker + "/favicon.ico"
		iconcache_elem = value.getElementsByTagName("iconcache")[0].firstChild
		if iconcache_elem: iconcache = iconcache_elem.data
		else:	iconcache = tmp_name(icon_cache_dir.value, icon)
		shownews = int(value.getElementsByTagName("shownews")[0].firstChild.data)
		new_feed = feed("", active, ticker, icon, iconcache,\
				shownews, "", "")
		#print "add_feed " + ticker + str(active)
		main.news.add_feed(new_feed)
	main.news.clean()

def refresh_ticker():
	global updatetimeout
	global updateset
	global main
	global update_possible
	global refresh_possible
	if refresh_possible:
		refresh_possible = False
	else:
		if v: print "refresh Ticker blocked"
		return
	if updateset: g.timeout_remove(updatetimeout)
	update_possible = False
	if v: print "refresh Ticker"
	global lastrefresh
	lastrefresh = time.time()
	#print "Vor Refresh 1: " + main.news.stat()
	convert_sources(sources)
	if v: print "found " + str(len(main.news.feeds)) + " sources"
	#print "Vor Refresh 1: " + main.news.stat()
	for i in main.news.feeds:
		if i.active <> "1": continue
		if not(os.path.isfile(i.iconcache)):
			icon = i.icon
			iconcache = i.iconcache
			if v: print "Getting Icon from " + icon
			if check_verbose.int_value:
				main.box.label.update("Getting Icon from " + icon); yield None
				main.box.image.setStockJump(); yield None
			if check_image.int_value:
				main.box.image.setStockJump(); yield None
			try:
				urllib.urlretrieve(icon,iconcache)
			except (IOError, EOFError):
				iconcache = rox.app_dir+"/AppIcon.xpm"
				if v: print "Icon at " + icon + " not retrieved"
				if check_verbose.int_value:
					main.box.label.update("Icon at " + icon + " not retrieved");
					main.box.image.setStockCancel()
				if check_image.int_value:
					main.box.image.setStockCancel()
				yield tasks.TimeoutBlocker(2)
	tasks.Task(check_feed())
	#check_feed()

def check_feed():		
	#print "Vor Refresh: " + main.news.stat()
	for fd in main.news.feeds:
		if fd.active == "1":
			if v: print "Checking " + fd.ticker + " ..."
			if check_verbose.int_value: 
				main.box.label.update("Checking " + fd.ticker + " ...")
				main.box.image.get_from_file(fd.iconcache)
			if check_image.int_value:
				main.box.image.setStockConvert() 
			yield None
			try:
				feed=urllib.urlopen(fd.ticker)
			except (IOError, EOFError):
				if v: print "could not open " + fd.ticker + " ..."
				if check_verbose.int_value: 
					main.box.label.update("could not open " + fd.ticker + " ...")
					main.box.image.get_from_file(fd.iconcache)
				if check_image.int_value:
					main.box.image.setStockCancel()
				yield tasks.TimeoutBlocker(2);
				continue
			try:
				xmldoc=minidom.parse(feed)
			except xml.sax.SAXParseException:
				if v: print "parse error in feed " + fd.ticker + " ..."
				if check_verbose.int_value: 
					main.box.label.update("parse error in feed " + fd.ticker + " ...")
					main.box.image.get_from_file(fd.iconcache)
				if check_image.int_value:
					main.box.image.setStockCancel()
				yield tasks.TimeoutBlocker(2);
				continue
			yield None
			#tasks.Task(main.news.read_xml(fd, xmldoc))
			main.news.read_xml(fd, xmldoc)
	print "Refresh done (" + main.news.stat() +")"
	main.news.export_xml()
	addTimeouts()
	update_ticker()


	
def addTimeouts():
	if v: print "add Timeouts"
	global update_possible
	update_possible = True
	global updatetimeout
	global updateset
	updatetimeout = g.timeout_add(1000*update_time.int_value, update_ticker)
	updateset = True
	global refresh_possible
	refresh_possible = True
	global refreshtimeout
	global refreshset
	refreshtimeout = g.timeout_add(60000*refresh_time.int_value, start_refresh_ticker_task)
	refreshset = True
	
#####################################################################################################
####### classes for the windows
#####################################################################################################

class TickBild(g.EventBox):
	def __init__(self):
		g.EventBox.__init__(self)
		#self.modify_bg(g.STATE_NORMAL,self.get_colormap().alloc_color('white'))
		self.image = g.Image()
    		self.pxbuf = g.gdk.pixbuf_new_from_file(rox.app_dir+"/AppIcon.xpm")
		self.get_from_file(rox.app_dir+"/AppIcon.xpm")
		self.image.show()
		self.add(self.image)
		self.tooltip = ttip()
		self.set_tip(" " + Version + " ")
		self.connect("button_press_event", callback_image)
		self.show_all()
		rox.app_options.add_notify(self.options_changed)
	def get_from_file(self,Filename):
    		if os.path.isfile(Filename):
			del self.pxbuf
			gc.collect()
			self.pxbuf = g.gdk.pixbuf_new_from_file(Filename)
    			im_icon_set = g.IconSet(self.pxbuf)
    			self.image.set_from_icon_set(im_icon_set,g.ICON_SIZE_SMALL_TOOLBAR)
		else:
			self.image.set_from_stock(g.STOCK_MISSING_IMAGE,g.ICON_SIZE_SMALL_TOOLBAR)
	def setStockJump(self):
		self.image.set_from_stock(g.STOCK_JUMP_TO,g.ICON_SIZE_SMALL_TOOLBAR)
	def setStockCancel(self):
		self.image.set_from_stock(g.STOCK_CANCEL,g.ICON_SIZE_SMALL_TOOLBAR)
	def setStockRefresh(self):
		self.image.set_from_stock(g.STOCK_REFRESH,g.ICON_SIZE_SMALL_TOOLBAR)
	def setStockConvert(self):
		self.image.set_from_stock(g.STOCK_CONVERT,g.ICON_SIZE_SMALL_TOOLBAR)
	def set_tip(self,Tip): self.tooltip.set_tip(self,Tip, None)
	def options_changed(self): options_changed()
	def quit(self): quit(self)
	def help(self): help()
	def show_options(self): show_options()
	def update_ticker(self): update_ticker()
	def refresh_ticker(self): tasks.Task(refresh_ticker())
	def show_window(self): tasks.Task(my_window.show_window())

class TickLabel(g.EventBox):
	def __init__(self):
		g.EventBox.__init__(self)
		self.modify_bg(g.STATE_PRELIGHT,self.get_colormap().alloc_color('white'))
		#self.modify_bg(g.STATE_NORMAL,self.get_colormap().alloc_color('white'))
		self.label = g.Label()
		self.label.set_text(" " + Version + " ")
		self.label.show()
		self.add(self.label)
		self.tooltip = ttip()
		self.set_tip(" " + Version + " ")
		self.connect("button_press_event", callback_label)
		#self.connect("button_press_event",go_,link.encode("ascii"))
		self.show_all()
		self.set_color()
	def update(self,Label):
		self.label.set_text(Label)
	def set_tip(self,Tip): self.tooltip.set_tip(self,Tip, None)
	def set_color(self): self.label.modify_fg(g.STATE_NORMAL, g.gdk.color_parse(text_color.value))

class Label_box(g.HBox):
    	def __init__(self):
    		g.HBox.__init__(self,g.FALSE, 0)
    		self.set_border_width(2)
		self.image = TickBild()
		self.label = TickLabel()
    		self.pack_start(self.image, g.FALSE, g.FALSE, 3)
    		self.pack_start(self.label, g.FALSE, g.FALSE, 3)
		self.show()

class TickerWindow(rox.Window):
        def __init__(self):
                global main
		main = self
		rox.Window.__init__(self)
                self.box = Label_box()
		self.add(self.box)
		self.position_menu = None
		self.connect("destroy", quit)
		self.set_size_request(hor_size.int_value, ver_size.int_value)
		self.set_title(" " + Version + " ")
		self.show()
		self.news = news_()
		self.show_list = show_list()
	def quit(self): quit(self)
	
class ttip(g.Tooltips):
	def __init__(self):
		g.Tooltips.__init__(self)
		self.enable

class TickerApplet(applet.Applet):
        def __init__(self):
                global main
		main = self
                applet.Applet.__init__(self,sys.argv[1])
                self.box = Label_box()
		self.add(self.box)
		self.connect("destroy", quit)
		self.set_size_request(hor_size.int_value, ver_size.int_value)
		self.show()
		self.news = news_()
		self.show_list = show_list()
	def quit(self): quit(self)

#####################################################################################################
####### diverse functions
#####################################################################################################

def options_changed():
	if update_time.has_changed or refresh_time.has_changed:
		global updatetimeout
		global refreshtimeout
		if updateset: g.timeout_remove(updatetimeout)
		if refreshset: g.timeout_remove(refreshtimeout)
		addTimeouts()
	if hor_size.has_changed or ver_size.has_changed:
		main.set_size_request(hor_size.int_value, ver_size.int_value)
	if text_color.has_changed:
		main.box.label.set_color()
	if transparent.has_changed or back_datei.has_changed:
		activate_transparency()

def main_routine():
	global pixbuf
	global pixbuf_label
	global pixbuf_image
	pixbuf = None
	pixbuf_label = None
	pixbuf_image = None
	activate_transparency()
	yield tasks.TimeoutBlocker(2)
#	yield None
	global refresh_possible
	refresh_possible = True
	#refresh_possible = False
	#addTimeouts()
	#update_ticker()
	tasks.Task(refresh_ticker())
 
def activate_transparency():
	global pixbuf_back
	global main
	if (transparent.int_value) == 0 or not(os.path.isfile(back_datei.value)):
		main.set_app_paintable(False)
		main.box.label.set_app_paintable(False)
		main.box.image.set_app_paintable(False)
		return
	pixbuf_back = g.gdk.pixbuf_new_from_file(back_datei.value)
	main.set_app_paintable(True)
	main.box.label.set_app_paintable(True)
	main.box.image.set_app_paintable(True)
	main.connect('configure-event',refresh_background)
	x, y = main.window.get_position()
	main.move(x+1, y)
	main.move(x-1, y)
	
def refresh_background(widget, value):
	global pixbuf_back
	global pixbuf
	global pixbuf_label
	global pixbuf_image
	w_b = pixbuf_back.get_width()
	h_b = pixbuf_back.get_height()
	x, y = main.window.get_position()
	w, h = main.get_size()
	if x < 0 or y < 0: return
	if x + w > w_b or y + h > h_b: return
	x_l, y_l = main.box.label.window.get_position()
	w_l, h_l = main.box.label.window.get_size()
	x_i, y_i = main.box.image.window.get_position()
	w_i, h_i = main.box.image.window.get_size()
	if pixbuf: del pixbuf
	pixbuf = g.gdk.Pixbuf(g.gdk.COLORSPACE_RGB, False, 8, w, h)
	if pixbuf_label: del pixbuf_label
	pixbuf_label = g.gdk.Pixbuf(g.gdk.COLORSPACE_RGB, False, 8, w_b - x - x_l, h_l)
	if pixbuf_image: del pixbuf_image
	pixbuf_image = g.gdk.Pixbuf(g.gdk.COLORSPACE_RGB, False, 8, w_i, h_i)
	pixbuf_back.copy_area(x, y, w, h, pixbuf, 0, 0)
	pixbuf_back.copy_area(x+x_l, y+y_l, w_b - x - x_l, h_l, pixbuf_label, 0, 0)
	pixbuf_back.copy_area(x+x_i, y+y_i, w_i, h_i, pixbuf_image, 0, 0)
	pixmap, mask = pixbuf.render_pixmap_and_mask()
	pixmap_label, mask = pixbuf_label.render_pixmap_and_mask()
	pixmap_image, mask = pixbuf_image.render_pixmap_and_mask()
	main.window.set_back_pixmap(pixmap, False)
	main.box.label.window.set_back_pixmap(pixmap_label, False)
	main.box.image.window.set_back_pixmap(pixmap_image, False)
	main.resize(w,h)
	main.box.label.hide()
	main.box.label.show()
	main.box.image.hide()
	main.box.image.show()
	
