#!/usr/bin/env python
from __future__ import generators
import findrox; findrox.version(1,9,12)
import rox
from rox import g
from Options import *
import RETicker
import tool

import time

""" a little python script to get rss feeds and display them """
################################################################
######## imported from a python script called ticker.py ########
################################################################
def go_(self, event, address):
	go(self,address)

def go(self, address):
        os.spawnlp(os.P_NOWAIT,browser.value,browser.value,br_options.value,address)
	


def description_window(self,dummy,dict):
	""" This function opens an additional Window with a text box showing
	the title, the description and a link """
	dwin = g.Window()
	swin = g.ScrolledWindow()
	vbox = g.VBox(spacing = 4)
	hbox = g.HBox()
	title = g.Label(tool.unxml(dict.title).encode("utf-8"))
	link = g.Button("Link")
	d_buffer = g.TextBuffer();
	description=g.TextView(d_buffer) 

	# Destroy is implied... I think...
	# dwin.connect("destroy", self.destroy)
	dwin.set_title(dict.title.encode("utf-8"))
	dwin.set_border_width(3)
	dwin.add(vbox)
	vbox.pack_start(hbox, False, False)
	vbox.add(swin)
	swin.add_with_viewport(description)
	description.set_editable(g.FALSE)
	description.set_cursor_visible(g.FALSE)
	description.set_wrap_mode(g.WRAP_WORD)
	#swin.set_size_request(150,100)
	swin.set_size_request(350,100)

	hbox.pack_start(title, expand=g.FALSE, fill=g.TRUE, padding = 2)
	hbox.pack_end(link, expand=False, fill=False, padding = 4)
	link.connect("clicked", go, dict.link.encode("ascii"))
	swin.set_policy(g.POLICY_AUTOMATIC, g.POLICY_AUTOMATIC)
	d_buffer.set_text(tool.unxml(dict.desc.encode("utf-8")));

	dwin.show_all();


def callback_window(widget, event, dict):
	if event.button == 1:
		go(None,dict.link.encode("ascii"))
	if event.button == 3:
		description_window(widget,event,dict)

def emptybox(box):
	
	for child in box.get_children():
		box.remove(child)
	return box
	
def show_it(vbox):
	""" this function shows all items """
	for fd in RETicker.main.news.feeds:
		if fd.active <> "1": continue
		title = fd.title
		link  = fd.link
		desc  = fd.desc
		ticker = ""
		sep=g.HSeparator()
		sep.show()
		vbox.pack_start(sep,g.FALSE,g.FALSE,0)
		vbox2 = g.VBox()
		vbox2.show()
		label_t=g.Label(tool.unxml(title).encode("utf-8"))
		label_t.set_alignment(0,0)
		label_t.show()
		if not(fd.valid):
			label_t.modify_fg(g.STATE_NORMAL,label_t.get_colormap().alloc_color('red'))
		label_d=g.Label(tool.unxml(desc).encode("utf-8"))
		label_d.set_alignment(0,0)
		label_d.show()
		vbox2.pack_start(label_t, g.FALSE, g.FALSE, 0)
		vbox2.pack_start(label_d, g.FALSE, g.FALSE, 0)
		image = RETicker.TickBild()
		image.modify_bg(g.STATE_NORMAL,image.get_colormap().alloc_color('white'))
		image.get_from_file(fd.iconcache)
		hbox = g.HBox()
		hbox.show()
		hbox.pack_start(image, g.FALSE, g.FALSE, 3)
		hbox.pack_start(vbox2, g.FALSE, g.FALSE, 3)
		ebox=g.EventBox()
		ebox.modify_bg(g.STATE_NORMAL,ebox.get_colormap().alloc_color('white'))
		ebox.modify_bg(g.STATE_PRELIGHT,ebox.get_colormap().alloc_color('red'))
		ebox.add(hbox)
		ebox.connect("button_press_event",go_,link.encode("ascii"))
		ebox.show_all()
		vbox.pack_start(ebox,g.FALSE,g.FALSE,0)
		count = 1
		for i in fd.msg:
			ebox=g.EventBox()
			#tooltip=g.Tooltips()
			page_time = 0
			if show_age.int_value == 1:
				page_time = i.fetchtime
				time_val = time.strftime("fetched %a %H:%M ", time.localtime(page_time))
				if i.time <> 0:	page_time = i.time; time_val += time.strftime("[%a %H:%M] ", time.localtime(page_time)) + " "
			else: 	time_val = ""
			label=g.Label(time_val + tool.unxml(i.title).encode("utf-8"))
			label.set_alignment(0,0)
			label.modify_fg(g.STATE_NORMAL,label.get_colormap().alloc_color(color_old_msg.value))
			if i.fetchtime + news_age.int_value*60 > time.time():
				label.modify_fg(g.STATE_NORMAL,label.get_colormap().alloc_color(color_new_msg.value))
			if count > fd.shownews:
				label.modify_fg(g.STATE_NORMAL,label.get_colormap().alloc_color(color_not_shown_msg.value))
			ebox.add(label)
			ebox.connect("button_press_event",callback_window,i)
			ebox.modify_bg(g.STATE_NORMAL,
			ebox.get_colormap().alloc_color('white'))
			#tooltip.set_tip(ebox,i['link'].encode("ascii"))
			label.show()
			ebox.show()
			vbox.pack_start(ebox,g.FALSE,g.FALSE,0)
			count += 1
	while g.events_pending():                                             
	            g.mainiteration(g.FALSE)
def show_window():
	window=g.Window()
	wbox=g.VBox()
	frame=g.Frame()
	swin=g.ScrolledWindow()
	window.set_title(" " + Version + " ")
	window.set_border_width(5)
	window.set_resizable(g.TRUE)
	window.connect("destroy", destroy)
	window.add(frame)
	frame.add(swin)
	frame.show()
	wbox.show()
	swin.add_with_viewport(wbox)
	swin.set_size_request(500,500)
	swin.modify_fg(g.STATE_NORMAL,
	swin.get_colormap().alloc_color('white'))
	swin.set_policy(g.POLICY_AUTOMATIC,g.POLICY_AUTOMATIC)
	swin.show()
	yield None
	show_it(wbox)
	window.show()

def destroy(self):
        g.main_quit()

################################################################
################################################################


